/* ------------------------------------------------------------------

File:		AviationWeatherGraphs.js
Abstract:	grahic drawing routines
Version:	1.2.10 (10/20/2008)
Author:		Pascal Dreer

------------------------------------------------------------------ */


var worldmap;

function preloadGraphImages()
{
	worldmap = new Image (220,111);
	worldmap.src = 'Images/worldmap.png';
/*	
	cloudImg = new Image(46,27);
	cloudImg.src = 'Images/cloudSCT.png';
	cloudImg.src = 'Images/cloudFEW.png';
	cloudImg.src = 'Images/cloudBKN.png';
	cloudImg.src = 'Images/cloudOVC.png';
	
	sunImg = new Image(50,50);
	sunImg.src = 'Images/WeatherIcons/sun.png';
	sunImg.src = 'Images/WeatherIcons/moon.png';	*/
}


// -----------------------------------------------------------
// STATION INFO
// -----------------------------------------------------------

function displayStationInfo(event)
{
		if (dataSource == 2)
			return;

		graphicalClear();
		document.getElementById('reportTypeImage').className = "Info";
		document.getElementById('flightRulesImage').className = "";
		timePrevImg.style.visibility = "hidden";
		timeNextImg.style.visibility = "hidden";

		var stationText = "<span class='topLeftSpacer'> </span><br><table id='plateD' border='0' width='265' cellpadding='1' cellspacing='0'>";
		
		var currentDate = new Date();		
		stationText = stationText + "<tr><td>" + getLocalizedString("Current local time:") + "</td><td>" + displayDateLine(currentDate,currentPreset,false,true) + "</td></tr>";

		if (presets[currentPreset].latitude >= 0)
			var laDir = "N";
		else
			var laDir = "S";
		if (presets[currentPreset].longitude >= 0)
			var loDir = "E";
		else
			var loDir = "W";
		
		stationText = stationText + "<tr><td>" + getLocalizedString("Latitude / Longitude:") + "</td><td>" + Math.abs(presets[currentPreset].latitude) + "° " + laDir + " / "
								+ Math.abs(presets[currentPreset].longitude) + "° " + loDir + "</td></tr>";
		
		
		var feetStr =  Math.round(presets[currentPreset].elevation * 3.2808399);
		stationText = stationText + "<tr><td>" + getLocalizedString("Elevation:") + "</td><td>" + feetStr + " " + getLocalizedString("feet") + " (" + presets[currentPreset].elevation + " " + getLocalizedString("meter") + ")</td></tr>";
		
		if (presets[currentPreset].timezone == 1)
			var hrsStr = getLocalizedString("hour");
		else
			var hrsStr = getLocalizedString("hours");
		
		var zeros = presets[currentPreset].timezone.indexOf("00");
		if (zeros > 0)
			var timezoneStr = presets[currentPreset].timezone.substring(0,zeros-1);
		else
			var timezoneStr = presets[currentPreset].timezone;
		
		if (presets[currentPreset].timezone < 0)
			stationText = stationText + "<tr><td>" + getLocalizedString("Timezone:") + "</td><td>UTC/GMT " + timezoneStr + " " + hrsStr + "</td></tr>";
		else
			stationText = stationText + "<tr><td>" + getLocalizedString("Timezone:") + "</td><td>UTC/GMT +" + timezoneStr + " " + hrsStr + "</td></tr>";
			
		var dateObj = new Date();
		stationText = stationText + "<tr valign='top'><td>" + getLocalizedString("Summertime:") + "</td><td>" + adjustSummertime(dateObj,currentPreset,true) + "</td></tr>";

		stationText = stationText +  "</table>";
		
		station1Body.innerHTML = stationText;
		gVScrollArea.reveal(document.getElementById('station1Body'));
		gVScrollArea.refresh();

		var front = document.getElementById("front");
		var hh = countTableHeight("plateD") + 75;
		resizeWindow(front,true,hh,false);


		canvas = document.getElementById("map");
		context = canvas.getContext("2d");
		
		context.clearRect(0,0,220,111);
		context.save();
	
		context.globalAlpha = 0.8;
		context.drawImage(worldmap,0,0);
		context.restore();
	
		if (presets[currentPreset].latitude >= 0)
			var laPixel = 55 - (presets[currentPreset].latitude * 0.61666);
		else
			var laPixel = 55 - (presets[currentPreset].latitude * 0.61666);

		if (presets[currentPreset].longitude >= 0)		
			var loPixel = 110 + (presets[currentPreset].longitude * 0.60833);
		else
			var loPixel = 110 + (presets[currentPreset].longitude * 0.60833);

	
		context.beginPath();
		context.arc(Math.floor(loPixel),Math.floor(laPixel),2.5,0,2 * Math.PI,false);
		context.fillStyle =" #FF0000";
		context.fill();
}


function clearStationInfo()
{
	var canvas = document.getElementById("map");
	var context = canvas.getContext("2d");
	context.clearRect(0,0,220,111);
}


// -----------------------------------------------------------
// WIND
// -----------------------------------------------------------

var prevWindDir = 0;

function graphDisplayWind(presetNo)
{
	var canvas = document.getElementById("wind1");
    var context = canvas.getContext("2d");
	
	var windPointer = new Image (10,26);
	windPointer.src = 'Images/pointer.png';
	
	var windDirArc = (Number(actDataDisplay[presetNo].gWindDir) * (2 * Math.PI / 360));

	
//	windPointer.style.visibility = "visible";
	
	context.clearRect(0,0,90,125);
	context.save();
	
	if (actDataDisplay[presetNo].gWindSpeed == 0 || actDataDisplay[presetNo].gWindDir == -1) {
		prevWindDir = 0;
//		context.arc(0,0,2,0,2 * Math.PI,false);
//		context.fillStyle =" #ED1C24";
//		context.fill();
		if (actDataDisplay[presetNo].gWindDir == 0)
			graphWind1.innerHTML = "---°";
		else
			graphWind1.innerHTML = getLocalizedString("variable");
	}
	else {
		graphInitPointer(prevWindDir,actDataDisplay[presetNo].gWindDir);
		prevWindDir = actDataDisplay[presetNo].gWindDir;
		graphWind1.innerHTML = actDataDisplay[presetNo].gWindDir + "°";
	}
	context.restore();
	
//	actDataDisplay[presetNo].gWindVar1 = 270;
//	actDataDisplay[presetNo].gWindVar2 = 30;

	var canvas = document.getElementById("wind1var");
	var context = canvas.getContext("2d");
	context.clearRect(0,0,80,80);
	
	if (actDataDisplay[presetNo].gWindVar1 != 0 && actDataDisplay[presetNo].gWindVar2 != 0) {
		varDeg1 = (Number(actDataDisplay[presetNo].gWindVar1) * (2 * Math.PI / 360));
		varDeg2 = (Number(actDataDisplay[presetNo].gWindVar2) * (2 * Math.PI / 360));
	}
	else {		
		varDeg1 = 0;
		varDeg2 = 0;
	}


	if (Number(actDataDisplay[presetNo].gWindSpeed) == 0)
		graphWind2.innerHTML = getLocalizedString("calm");
	else
		graphWind2.innerHTML = actDataDisplay[presetNo].gWindSpeed + " kts";
		
	if (actDataDisplay[presetNo].gWindGusts > 0) {
		graphWindGusts.innerHTML = actDataDisplay[presetNo].gWindGusts + " kts";
		graphWind2Img.style.visibility = "visible";
	}
	else { 
		graphWindGusts.innerHTML = "";
		graphWind2Img.style.visibility = "hidden";
	}
}




function graphRotateDrawPointer(angle)
{
	var windPointer = new Image (10,26);
	windPointer.src = 'Images/pointer.png';
	
	var canvas = document.getElementById("wind1");
    var context = canvas.getContext("2d");

	
	context.clearRect(0,0,80,80);

	context.save();
	context.translate(33,37);

	context.rotate(angle);
//	context.drawImage(windPointer,-5,-21);
	context.drawImage(windPointer,-5,-36);
	context.restore();
}


var slideTimer = {timer:null, points:[], to:0, cnt:0, interval:50};
var windVarTimer = {timer:null, points1:[], points2:[], clockwise:true, cnt:0, interval:50};

function graphInitPointer(fromDeg,toDeg)
{
	var fromArc = (Number(fromDeg) * (2 * Math.PI / 360));
	var toArc = (Number(toDeg) * (2 * Math.PI / 360));
	
	if (fromDeg == toDeg) {				// don't do anything if same angle
		graphRotateDrawPointer(toArc);
		return;
	}

	slideTimer.to = toArc;

	var diffArc = toArc - fromArc;
		
	for (var theta=0; theta<90; theta+=5) {
			var step = Math.sin((theta * Math.PI) / 180);
			slideTimer.points.push(fromArc + (diffArc * step));
	}

	if (slideTimer.timer != null) {
		clearInterval(slideTimer.timer);
		slideTimer.timer = null;
	}
	slideTimer.timer = setInterval("graphSlidePointer();",slideTimer.interval);
}


function graphSlidePointer()
{
	if (++slideTimer.cnt < slideTimer.points.length) {
		graphRotateDrawPointer(slideTimer.points[slideTimer.cnt]);
	} else {
//			self.rotate(to);
		if (slideTimer.timer != null) {
			clearInterval(slideTimer.timer);
			slideTimer.timer = null;
		}
		if (varDeg1 != 0 && varDeg2 != 0) {
			graphInitSplitPointer(slideTimer.to,varDeg1,varDeg2);
		}	
	}
}



function graphInitSplitPointer(fromDeg,toDeg1,toDeg2)
{
	var diffArc1 = (fromDeg - toDeg1) * (-1);
	var diffArc2 = (fromDeg - toDeg2) * (-1);
	if (diffArc1 > Math.PI)
		diffArc1 = diffArc1 - 2 * Math.PI;
	
	if (diffArc2 < (-Math.PI))
		diffArc2 = diffArc2 + 2 * Math.PI;

	for (var theta=0; theta<90; theta+=5) {
		var step = Math.sin((theta * Math.PI) / 180);
		windVarTimer.points1.push(fromDeg + (diffArc1 * step));
		windVarTimer.points2.push(fromDeg + (diffArc2 * step));
	}

	if (windVarTimer.timer != null) {
		clearInterval(windVarTimer.timer);
		windVarTimer.timer = null;
	}
	windVarTimer.timer = setInterval("graphSlideSplitPointer();",windVarTimer.interval);
}


function graphSlideSplitPointer()
{
	if (++windVarTimer.cnt < windVarTimer.points2.length) {
		graphRotateDrawSplitPointer(windVarTimer.points1[windVarTimer.cnt],windVarTimer.points2[windVarTimer.cnt]);
	} else {
		if (windVarTimer.timer != null) {
			clearInterval(windVarTimer.timer);
			windVarTimer.timer = null;
		}
	}
}


function graphRotateDrawSplitPointer(angle1,angle2)
{
	var windPointer = new Image (10,26);
	windPointer.src = 'Images/pointerSplit.png';
	
	var canvas = document.getElementById("wind1var");
    var context = canvas.getContext("2d");
	
	context.clearRect(0,0,80,80);
	
	context.save();
	context.translate(33,37);
	context.rotate(angle1);
	context.drawImage(windPointer,-4,-36);
	context.restore();
	
	context.save();
	context.translate(33,37);
	context.rotate(angle2);
	context.drawImage(windPointer,-4,-36);

	context.restore();
}



// -----------------------------------------------------------
// CLOUDS
// -----------------------------------------------------------

function graphDisplayClouds(presetNo) 
{
	
	var canvas = document.getElementById("clouds");
    var context = canvas.getContext("2d");

	context.clearRect(0,0,100,60);
	context.save();
	
	var lt = displayDateLine(actDataDisplay[presetNo].mDate,presetNo,false,showLocalTime);
	if (lt > actDataDisplay[presetNo].sunrise && lt < actDataDisplay[presetNo].sunset)
		sunImg.src = 'Images/WeatherIcons/sun.png';
	else
		sunImg.src = 'Images/WeatherIcons/moon.png';
	context.translate(0,0);
	context.drawImage(sunImg,0,5);
	
	if (actDataDisplay[presetNo].gCloud2 == "" && actDataDisplay[presetNo].gCloud3 == "") {		// put in middle if there's only one
		graphParseCloudType(context,actDataDisplay[presetNo].gCloud1,"cloudsAlt2",20);
		graphParseCloudType(context,actDataDisplay[presetNo].gCloud2,"cloudsAlt1",35);
		graphParseCloudType(context,actDataDisplay[presetNo].gCloud3,"cloudsAlt3",5);
	}
	else {
		graphParseCloudType(context,actDataDisplay[presetNo].gCloud1,"cloudsAlt1",35);
		graphParseCloudType(context,actDataDisplay[presetNo].gCloud2,"cloudsAlt2",20);
		graphParseCloudType(context,actDataDisplay[presetNo].gCloud3,"cloudsAlt3",5);
	}
		
	if (actDataDisplay[presetNo].gCloud1 != "" || actDataDisplay[presetNo].gCloud2 != "" || actDataDisplay[presetNo].gCloud3 != "") {
		context.beginPath();
		context.moveTo(55,14);
		context.lineTo(60,14);
		context.moveTo(55,34);
		context.lineTo(60,34);
		context.moveTo(55,54);
		context.lineTo(60,54);
		context.strokeStyle =" #BEBEBE";
		context.stroke();
	}

	context.restore();
}



function graphParseCloudType(con,cloudCode,position,posTop)
{
	var level = "";
		
	var label = document.getElementById(position);
	if (cloudCode != "") {
		if (cloudCode.charAt(6) == "C" && cloudCode.charAt(7) == "B") {
			tmpVal = parseInt(cloudCode.substr(3,3),10) * 100;
			level = "C ";
		}
		else
			tmpVal = parseInt(cloudCode.substr(3,3),10) * 100;
			
		if (isNaN(tmpVal))
			level = "";
		else
			level = level + tmpVal + "ft";
		graphDrawCloudType(con,cloudCode,posTop);
	}
	else
		level = "";
	
	label.innerHTML = level;
	return level;
}



function graphDrawCloudType(con,cloudType,ypos)
{	
	if (cloudType.indexOf("SCT") >= 0)
		cloudImg.src = 'Images/cloudSCT.png';
	else if (cloudType.indexOf("FEW") >= 0)
		cloudImg.src = 'Images/cloudFEW.png';
	else if (cloudType.indexOf("BKN") >= 0)
		cloudImg.src = 'Images/cloudBKN.png';
	else if (cloudType.indexOf("OVC") >= 0)
		cloudImg.src = 'Images/cloudOVC.png';
	else
		;
	
	con.translate(0,0);
	con.drawImage(cloudImg,0,ypos);
}


// -----------------------------------------------------------
// VISIBILITY BAR
// -----------------------------------------------------------

var prevVisibility = 0;

function graphDisplayVisibility(presetNo) 
{
	var label = document.getElementById("visibilityText");
	
	if (actDataDisplay[presetNo].gVisibility >= 10000) {
		var xpos = 100;
		label.innerHTML = (actDataDisplay[presetNo].gVisibility / 1000) + " km";
	}
	else {
		var xpos = (100 / 10000) * actDataDisplay[presetNo].gVisibility;
		label.innerHTML = actDataDisplay[presetNo].gVisibility + " meter";
	}
	
	graphInitVisibility(prevVisibility,xpos);
	prevVisibility = xpos;
}



var visibilityTimer = {timer:null, points:[], to:0, cnt:0, interval:50};

function graphInitVisibility(fromPos,toPos)
{
	visibilityTimer.to = toPos;

	var diffPos = toPos - fromPos;
		
	for (var theta=0; theta<90; theta+=5) {
			var step = Math.sin((theta * Math.PI) / 180);
			visibilityTimer.points.push(fromPos + (diffPos * step));
	}

	if (visibilityTimer.timer != null) {
		clearInterval(visibilityTimer.timer);
		visibilityTimer.timer = null;
	}
	visibilityTimer.timer = setInterval("graphSlideVisibility();",visibilityTimer.interval);
}


function graphSlideVisibility()
{
	if (++visibilityTimer.cnt < visibilityTimer.points.length) {
		graphDrawVisibility(visibilityTimer.points[visibilityTimer.cnt]);
	} else {
//			self.rotate(to);
		if (visibilityTimer.timer != null) {
			clearInterval(visibilityTimer.timer);
			visibilityTimer.timer = null;
		}
	}
}

function graphDrawVisibility(position)
{
	var canvas = document.getElementById("visibility");
    var context = canvas.getContext("2d");

	var triangleImg = new Image(10,10);
	triangleImg.src = 'Images/triangle.png';
	
	context.clearRect(0,0,120,25);
	context.save();
//	context.clearRect(0,0,120,25);
	context.translate(0,0);
	context.drawImage(triangleImg,position,6);
	context.restore();
}



// -----------------------------------------------------------
// WEATHER
// -----------------------------------------------------------

function graphDisplayWeather(presetNo) 
{
	var canvas = document.getElementById("weather");
    var context = canvas.getContext("2d");
	
	var weather = new Image(100,20);
	var desc1 = "";
	var desc2 = "";
	
	desc1 = parseWeatherDescriptor(actDataDisplay[presetNo].gWeather1);
	desc2 = parseWeatherDescriptor(actDataDisplay[presetNo].gWeather2);
			
	switch (actDataDisplay[presetNo].gWeather1) {
		case "MI": weather.src = 'Images/WeatherIcons/mist.png';
					//desc2 = getLocalizedString("shallow");
			break;
		case "BC": desc2 = getLocalizedString("patches");
			break;
		case "PR": desc2 = getLocalizedString("partial");
			break;
		case "DR": desc2 = getLocalizedString("low drifting");
			break;
		case "BL": desc2 = getLocalizedString("blowing");
			break;
		case "SH": weather.src = 'Images/WeatherIcons/rain.png';
					//desc2 = getLocalizedString("showers");
			break;
		case "TS": desc2 = getLocalizedString("thunderstorm");
			break;
		case "FZ": desc2 = getLocalizedString("freezing");
			break;
		case "DZ": desc2 = getLocalizedString("drizzle");
			break;
		case "RA": weather.src = 'Images/WeatherIcons/rain.png';
					//desc2 = getLocalizedString("rain");
			break;
		case "SN": desc2 = getLocalizedString("snow");
			break;
		case "SG": desc2 = getLocalizedString("snow grains");
			break;
		case "IC": desc2 = getLocalizedString("ice crystals");
			break;
		case "PL": desc2 = getLocalizedString("ice pellets");
			break;
		case "GR": desc2 = getLocalizedString("hail");
			break;
		case "GS": desc2 = getLocalizedString("small hail or snow pellets");
			break;
		case "FG": weather.src = 'Images/WeatherIcons/mist.png';
					//desc2 = getLocalizedString("fog");
			break;
		case "BR": weather.src = 'Images/WeatherIcons/mist.png';
					//desc2 = getLocalizedString("mist");
			break;
		case "FU": desc2 = getLocalizedString("smoke");
			break;
		case "VA": desc2 = getLocalizedString("volcanic ash");
			break;
		case "DU": desc2 = getLocalizedString("widespread dust");
			break;
		case "SA": desc2 = getLocalizedString("sand");
			break;
		case "HZ": weather.src = 'Images/WeatherIcons/mist.png';
					//desc2 = getLocalizedString("haze");
			break;
		case "PO": desc2 = getLocalizedString("dust/sand whirls");
			break;
		case "SQ": desc2 = getLocalizedString("squalls");
			break;
		case "FC": desc2 = getLocalizedString("funnel clouds");
			break;
		case "SS": desc2 = getLocalizedString("sandstorm");
			break;
		case "DS": desc2 = getLocalizedString("duststorm");
			break;
		default:
			break;
	}
	

	context.clearRect(0,0,100,20);
	context.save();
	context.drawImage(weather,0,0);		
	context.restore();

	var label = document.getElementById("weatherText");
	label.innerHTML = desc1;
	if (desc2 != "")
		label.innerHTML = desc1 + " " + desc2;
}




function stopAllAnimationTimers() 
{
	if (visibilityTimer.timer != null) {
		clearInterval(visibilityTimer.timer);
		visibilityTimer.timer = null;
	}

	if (windVarTimer.timer != null) {
		clearInterval(windVarTimer.timer);
		windVarTimer.timer = null;
	}

	if (slideTimer.timer != null) {
		clearInterval(slideTimer.timer);
		slideTimer.timer = null;
	}
}

