/* ------------------------------------------------------------------

File:		AviationWeatherPrefs.js
Abstract:	widget setup routines; preferences handling
Version:	1.2.10 (10/20/2008)
Author:		Pascal Dreer

------------------------------------------------------------------ */


function openExternalLink(myUrl)
{
	if (window.widget) {
		widget.openURL(myUrl);
	}
}


function openExternalInfoLink()
{
	var infoURL = "";
	
	switch (dataSource) {
		case 1:	infoURL = "";
				break;
		case 2:	infoURL = "http://www.MyMetar.com/";
				break;
		default:
				infoURL = "";
	}
	
	if (window.widget && infoURL != "")
		widget.openURL(infoURL);
}



function getTagValue(theStr,startTag,endTag,startPos) 
{
	var posA = theStr.indexOf(startTag,startPos);
	if (posA == -1)
		return "";
	var posB = theStr.indexOf(endTag,posA + startTag.length);
	if (posB > posA)
		return theStr.substring(posA + startTag.length,posB);
	else
		return "";
}



function getKeyValue(plist,key,isXML) 
{ 
	if (!isXML) {
		var xml_http = new XMLHttpRequest(); 
		xml_http.open("GET", plist, false); 
		xml_http.send(null);
	}
	else {
		var xml_http = plist;
	}

	var offset = xml_http.responseText.indexOf('<key>'+key+'</key>',0)+11+key.length; 
	offset = xml_http.responseText.indexOf('>',offset)+1; 
	var offset2 = xml_http.responseText.indexOf('<',offset); 
	return xml_http.responseText.substring(offset,offset2); 
}


function createkey(key)
{
	if (keepPrefs)
		return key;
	else
		return widget.identifier + "-" + key;
}


function checkLatestVersion()
{
	xml_request_version = new XMLHttpRequest();
	xml_request_version.onreadystatechange = processReqVersion;
	xml_request_version.overrideMimeType("text/xml");

	var url = 'http://www.flightlevel.ch/widgets/aviation_weather/downloads/aviation-weather-version.xml';
	xml_request_version.open("GET",url,true);
	xml_request_version.send();
}


function processReqVersion() 
{
    // only if req shows "loaded"
    if (xml_request_version.readyState == 4) {
        // only if "OK"
        if (xml_request_version.status == 200) {
			var latestVersion = "";
			latestVersion = getKeyValue(xml_request_version,"LatestVersion",true);
			var lateVal = (parseInt(latestVersion.charAt(0),10) * 1000) + (parseInt(latestVersion.charAt(2),10) * 100) + parseInt(latestVersion.substring(4,latestVersion.length),10);
			
			var currentVersion = getKeyValue("Info.plist","CFBundleVersion",false);
			var curVal = (parseInt(currentVersion.charAt(0),10) * 1000) + (parseInt(currentVersion.charAt(2),10) * 100) + parseInt(currentVersion.substring(4,currentVersion.length),10);
			
			if (lateVal > curVal)
				document.getElementById('versionText').innerText = getLocalizedString('New version available') + ": " + latestVersion;
			else
				document.getElementById('versionText').innerText = "";
		}
	}
}


/***********************************/
// SAVING AND RETRIEVING PREFERENCES
/***********************************/

var everBeenCalled = false;
function setup()
{
	graphicalClear();
	populateSelectMenus();

	if (window.widget) {			// The preferences are retrieved:

		var pref = widget.preferenceForKey("show-keepPrefs");
		if (pref != null) {
			document.getElementById('showKeepPrefsCheckbox').checked = pref;
			keepPrefs = pref;
		}
		else {
			pref = widget.preferenceForKey(createkey("show-keepPrefs"));	// *** fixed prefs loading bug
			if (pref != null) {
				document.getElementById('showKeepPrefsCheckbox').checked = pref;
				keepPrefs = pref;
			}
			else {
				document.getElementById('showKeepPrefsCheckbox').checked = true;
				keepPrefs = true;
			}
		}

		pref = widget.preferenceForKey(createkey("show-all"));
		if (pref != null) {
			document.getElementById('showAllCheckbox').checked = pref;
			showAll = pref;
		}
		else {
			document.getElementById('showAllCheckbox').checked = false;
			showAll = false;
		}

		pref = widget.preferenceForKey(createkey("data-source"));
		if (pref != null) {
			document.getElementById('sourcePopup').options[parseInt(pref)-1].selected = true;
			dataSource = pref;
		}
		else {
			document.getElementById('sourcePopup').options[0].selected = true;
			dataSource = 1;
		}

		pref = widget.preferenceForKey(createkey("username"));
		if (pref != null) {
			document.getElementById('usernameInput').value = pref;
			username = pref;
		}
		else {
			document.getElementById('usernameInput').value = "";
			username = "";
		}

		pref = widget.preferenceForKey(createkey("display-format"));
		if (pref != null) {
			document.getElementById('formatPopup').options[parseInt(pref)-1].selected = true;
			displayFormat = pref;
		}
		else {
			document.getElementById('formatPopup').options[1].selected = true;
			displayFormat = 2;
		}
		
		pref = widget.preferenceForKey(createkey("metric-format"));
		if (pref != null) {
			document.getElementById('metricPopup').options[parseInt(pref)-1].selected = true;
			metricFormat = pref;
		}
		else {
			document.getElementById('metricPopup').options[0].selected = true;
			metricFormat = 1;
		}

		pref = widget.preferenceForKey(createkey("show-remarks"));
		if (pref != null) {
			document.getElementById('showRMKCheckbox').checked = pref;
			showRMK = pref;
		}
		else {
			document.getElementById('showRMKCheckbox').checked = true;
			showRMK = true;
		}

		pref = widget.preferenceForKey(createkey("show-rawFormat"));
		if (pref != null) {
			document.getElementById('showRawFormatCheckbox').checked = pref;
			showRawFormat = pref;
		}
		else {
			document.getElementById('showRawFormatCheckbox').checked = true;
			showRawFormat = true;
		}

		pref = widget.preferenceForKey(createkey("show-time"));
		if (pref != null) {
			document.getElementById('showTimeCheckbox').checked = pref;
			showLocalTime = pref;
		}
		else {
			document.getElementById('showTimeCheckbox').checked = false;
			showLocalTime = false;
		}

		pref = widget.preferenceForKey(createkey("show-calc"));
		if (pref != null) {
			document.getElementById('showCalcCheckbox').checked = pref;
			showCalc = pref;
		}
		else {
			document.getElementById('showCalcCheckbox').checked = false;
			showCalc = false;
		}

		pref = widget.preferenceForKey(createkey("show-keepPastData"));
		if (pref != null) {
			document.getElementById('showKeepPastDataCheckbox').checked = pref;
			keepPastData = pref;
		}
		else {
			document.getElementById('showKeepPastDataCheckbox').checked = false;
			keepPastData = false;
		}
		
		currentPreset = 0;
		var numOfPresetsLoaded = 0;
		for (var i=1;i<5;i++)
			numOfPresetsLoaded = numOfPresetsLoaded + populatePresets(i);
				
		if (numOfPresetsLoaded == 0) {
			presets[0] = new Object();
			presets[0].icao = "";
			currentPreset = 0;
			
			var pref = widget.preferenceForKey(createkey("stn1-icao"));	
			if (pref && pref.length > 0) {
				presets[0].icao = pref;
				var pref = widget.preferenceForKey(createkey("stn1-name"));
				if (pref && pref.length > 0) {
					presets[0].name = pref;
					document.getElementById('stn1input').value = pref;
				}
				else {
					presets[0].name = "undefined station";
					document.getElementById('stn1input').value = "undefined station";				
				}
				stationValidated = true;
			}
			else {
				presets[0].icao = "LSZB";
				widget.setPreferenceForKey(presets[0].icao,createkey("stn1-icao"));

				presets[0].name = "Bern/Belp, CH";
				widget.setPreferenceForKey(presets[0].name,createkey("stn1-name"));
				document.getElementById('stn1input').value = presets[0].name;
				presets[0].latitude = "46.916";
				presets[0].longitude = "7.500";
				presets[0].timezone = "1.00";
				presets[0].summertime = 1;
				presets[0].elevation = "505";
				stationValidated = true;
			}
		}
		else {
			// what to do
			presets[0] = new Object();
			presets[0].icao = "";
			
		}
	}
	
/*  for tests only		*/	
/*	dataSource = 1;
	displayFormat = 2;
	metricFormat = 3;
	showAll = false;
	showRMK = true;
	showLocalTime = true;
	showRawFormat = true;
	showCalc = true;
	keepPrefs = false;
	keepPastData = false;
	presets[0] = new Object();
	presets[0].icao = "EBLG";
	presets[0].name = "EBLG";
	presets[0].latitude = 41.35;
	presets[0].longitude = -83.48;
	presets[0].timezone = "1.00";
	presets[0].summertime = 1;
	presets[0].elevation = "100";
	username = "pascal";


	document.getElementById('presetBox1').innerText = "KVPS";
	document.getElementById('presetFront1').innerText = "KVPS";
	document.getElementById('presetBox2').innerText = "SLLP";
	document.getElementById('presetFront2').innerText = "SLLP";
	document.getElementById('presetBox3').innerText = "UHWW";
	document.getElementById('presetFront3').innerText = "UHWW";
	document.getElementById('presetBox4').innerText = "YSSY";
	document.getElementById('presetFront4').innerText = "YSSY";
	presets[1] = new Object();
	presets[1].icao = "KVPS";
	presets[1].name = "KVPS";
	presets[1].latitude = 43.39;
	presets[1].longitude = 7.12;
	presets[1].timezone = "1.00";
	presets[1].summertime = 1;
	presets[1].elevation = "490";
	presets[2] = new Object();
	presets[2].icao = "SLLP";
	presets[2].name = "SLLP";
	presets[2].latitude = 47.36;
	presets[2].longitude = 7.3;
	presets[2].timezone = "-4.00";
	presets[2].summertime = 0;
	presets[2].elevation = "200";
	presets[3] = new Object();
	presets[3].icao = "UHWW";
	presets[3].name = "UHWW";
	presets[3].latitude = 41.35;
	presets[3].longitude = -83.48;
	presets[3].timezone = "-5.00";
	presets[3].summertime = 3;
	presets[3].elevation = "300";
	presets[4] = new Object();
	presets[4].icao = "YSSY";
	presets[4].name = "YSSY";
	presets[4].latitude = 22.566;
	presets[4].longitude = 17.10;
	presets[4].timezone = "1.00";
	presets[4].summertime = 1;
	presets[4].elevation = "2835";
	currentPreset = 1;	
 */

	if (displayFormat == 1) {
		document.getElementById('showAllText').style.visibility = "visible";
		document.getElementById('showAllCheckbox').style.visibility = "visible";
		document.getElementById('showRawFormatText').style.visibility = "visible";
		document.getElementById('showRawFormatCheckbox').style.visibility = "visible";
		document.getElementById('showRMKText').style.visibility = "hidden";
		document.getElementById('showRMKCheckbox').style.visibility = "hidden";
		document.getElementById('showTimeText').style.visibility = "hidden";
		document.getElementById('showTimeCheckbox').style.visibility = "hidden";
		document.getElementById('metricPopup').style.visibility = "hidden";
		document.getElementById('showCalcCheckbox').style.visibility = "hidden";
		document.getElementById('reportTypeImage').className = "";
	}
	
	if (displayFormat == 2) {
		var front = document.getElementById("front");
		resizeWindow(front,true,230,false);
		document.getElementById('showAllText').style.visibility = "hidden";
		document.getElementById('showAllCheckbox').style.visibility = "hidden";
		document.getElementById('showRawFormatText').style.visibility = "hidden";
		document.getElementById('showRawFormatCheckbox').style.visibility = "hidden";
		document.getElementById('showRMKText').style.visibility = "visible";
		document.getElementById('showRMKCheckbox').style.visibility = "visible";
		document.getElementById('showTimeText').style.visibility = "visible";
		document.getElementById('showTimeCheckbox').style.visibility = "visible";
		document.getElementById('metricPopup').style.visibility = "visible";
		document.getElementById('showCalcCheckbox').style.visibility = "visible";
		document.getElementById('reportTypeImage').className = "METAR";
	}
	
	timePrevImg.style.visibility = "hidden";
	timeNextImg.style.visibility = "hidden";


	document.getElementById('frontText').innerText = getLocalizedString('Aviation Weather');
	document.getElementById('stationText').innerText = getLocalizedString('Station:');
	document.getElementById('formatText').innerText = getLocalizedString('Format:');
	document.getElementById('sourceText').innerText = getLocalizedString('Data-Source:');
	document.getElementById('presetText').innerText = getLocalizedString('Presets:');
	document.getElementById('showAllText').innerText = getLocalizedString('Show all stations at once');
	document.getElementById('showRMKText').innerText = getLocalizedString('Show METAR remarks');
	document.getElementById('showTimeText').innerText = getLocalizedString('Show local time (LT)');
	document.getElementById('showCalcText').innerText = getLocalizedString('Show calculations');
	document.getElementById('showRawFormatText').innerText = getLocalizedString('Format data nicer');
	document.getElementById('showKeepPrefsText').innerText = getLocalizedString('Keep preferences when removing widget');
	document.getElementById('showKeepPastDataText').innerText = getLocalizedString('Get past data if current unavailable');
	document.getElementById('usernameText').innerText = getLocalizedString('User name:');
	document.getElementById('optionsText').innerText = getLocalizedString('Options:');
	

	var currentVersion = getKeyValue("Info.plist","CFBundleVersion",false); 	
	document.getElementById('aboutText').innerText = getLocalizedString('Version') + " " + currentVersion + " " + getLocalizedString('by') + " Pascal Dreer";

	gDoneButton = new AppleGlassButton(document.getElementById('doneBtn'),getLocalizedString('Done'),hidePrefs);
	
	firstConnection = true;
	actGroupDataSelected = 0;
	
	preloadGraphImages();
 
    gVScrollbar = new AppleVerticalScrollbar(document.getElementById("vScrollbar"));		// init scrollbars
    gVScrollArea = new AppleScrollArea(document.getElementById("parentDiv"));
	gVScrollArea.addScrollbar(gVScrollbar);

	gVScrollArea.scrollsHorizontally = false;
	gVScrollArea.singlepressScrollPixels = 25;
	gVScrollArea.focus();	// for key control when first loading in Safari

	if (window.widget) {
		window.onfocus = function () { gVScrollArea.focus(); }
		window.onblur = function () { gVScrollArea.blur(); }
	}
	
	changeSource(document.getElementById('sourcePopup'));
	
	
	if (!everBeenCalled) {
		onshow();
		everBeenCalled = true;
	}
	return 0;
}


function populatePresets(presetNo)
{
	var presetLoaded = 0;

	if (presetNo >= 1 && presetNo <= 4) {
		presets[presetNo] = new Object();
		presets[presetNo].icao = "";

		pref = widget.preferenceForKey(createkey("preset" + presetNo + "-icao"));
		if (pref && pref.length > 0) {
			document.getElementById("presetBox" + presetNo).innerText = pref;
			document.getElementById("presetFront" + presetNo).innerText = pref;
			if ((!showAll && displayFormat != 1) || displayFormat >= 2)
				document.getElementById("presetFront" + presetNo).style.visibility = "visible";
			else
				document.getElementById("presetFront" + presetNo).style.visibility = "hidden";
				
			presets[presetNo].icao = pref;
			
			pref = widget.preferenceForKey(createkey("preset" + presetNo + "-name"));
			if (pref && pref.length > 0)
				presets[presetNo].name = pref;
			else
				presets[presetNo].name = "";
			pref = widget.preferenceForKey(createkey("preset" + presetNo + "-latitude"));
			if (pref && pref.length > 0)
				presets[presetNo].latitude = pref;
			else
				presets[presetNo].latitude = "";
			pref = widget.preferenceForKey(createkey("preset" + presetNo + "-longitude"));
			if (pref && pref.length > 0)
				presets[presetNo].longitude = pref;
			else
				presets[presetNo].longitude = "";
			pref = widget.preferenceForKey(createkey("preset" + presetNo + "-timezone"));
			if (pref != null)
				presets[presetNo].timezone = pref;
			else
				presets[presetNo].timezone = "0.00";
			pref = widget.preferenceForKey(createkey("preset" + presetNo + "-summertime"));
			if (pref != null)
				presets[presetNo].summertime = pref;		// presets[presetNo].summertime = parseInt(pref,10);
			else
				presets[presetNo].summertime = 0;
			pref = widget.preferenceForKey(createkey("preset" + presetNo + "-elevation"));
			if (pref != null)
				presets[presetNo].elevation = pref;
			else {
				presets[presetNo].elevation = findStationElevation(presets[presetNo].icao);
				widget.setPreferenceForKey(presets[presetNo].elevation,createkey("preset" + presetNo + "-elevation"));
			}
			
			if (currentPreset == 0 && (!showAll || displayFormat != 1)) {
				currentPreset = presetNo;
				var element = document.getElementById("presetFront" + presetNo);	// make button selected
				element.className = 'selectedPreset';
			}
			
			presetLoaded = 1;
		}
		else {
			document.getElementById("presetBox" + presetNo).innerText = "+";
			document.getElementById("presetFront" + presetNo).innerText = "";
			document.getElementById("presetFront" + presetNo).style.visibility = "hidden";
			presets[presetNo].icao = "";
		}
	}
	
	return presetLoaded;
}



function populateSelectMenus() 
{
	var select = document.getElementById('formatPopup');
	var element;

	element = document.createElement("option");
	element.value = 1;
	element.innerText = getLocalizedString("Raw");
	select.appendChild(element);
	element = document.createElement("option");
	element.value = 2;
	element.innerText = getLocalizedString("Translated");
	select.appendChild(element);
//	element = document.createElement("option");
//	element.value = 3;											
//	element.innerText = getLocalizedString("Graphical");
//	select.appendChild(element);

	select = document.getElementById('metricPopup');
	element = document.createElement("option");
	element.value = 1;
	element.innerText = getLocalizedString("U.S.");
	select.appendChild(element);
	element = document.createElement("option");
	element.value = 2;
	element.innerText = getLocalizedString("U.S. (deg.C)");
	select.appendChild(element);
	element = document.createElement("option");
	element.value = 3;
	element.innerText = getLocalizedString("Metric");
	select.appendChild(element);
	element = document.createElement("option");
	element.value = 4;
	element.innerText = getLocalizedString("Metric All");
	select.appendChild(element);
	
	select = document.getElementById('sourcePopup');
	element = document.createElement("option");
	element.value = 1;
	element.innerText = getLocalizedString("National Weather Service");
	select.appendChild(element);
	element = document.createElement("option");
	element.value = 2;
	element.innerText = "MyMetar.com";
	select.appendChild(element);
}	


function populateMyMetarGroupMenu(groupArray) 
{
	var select = document.getElementById('groupPopup');
	var element;

	while (select.firstChild) {							// remove old entries first
		select.removeChild(select.firstChild);
	}
	document.getElementById('groupPopupLabel').innerText = "";

	if (groupArray == null) {
		actGroupDataSelected = 0;
		return;
	}
		
	for (var i=0;i<groupArray.length;i++) {				// build popup menu
		element = document.createElement("option");
		element.value = i;
		element.innerText = groupArray[i].groupName;
		select.appendChild(element);
//		if (i == 0)
//			document.getElementById('groupPopupLabel').innerText = groupArray[i].groupName;
	}
	
	if (actGroupDataSelected >= groupArray.length)
		actGroupDataSelected = 0;
		
	select.options[parseInt(actGroupDataSelected)].selected = true;
	document.getElementById('groupPopupLabel').innerText = groupArray[actGroupDataSelected].groupName;
}



function saveAllPrefs()
{
	if (window.widget) {
		widget.setPreferenceForKey(metricFormat,createkey("metric-format"));
		widget.setPreferenceForKey(dataSource,createkey("data-source"));
		widget.setPreferenceForKey(displayFormat,createkey("display-format"));
		widget.setPreferenceForKey(showAll,createkey("show-all"));
		widget.setPreferenceForKey(showRMK,createkey("show-remarks"));
		widget.setPreferenceForKey(showRawFormat,createkey("show-rawFormat"));
		widget.setPreferenceForKey(showLocalTime,createkey("show-time"));
		widget.setPreferenceForKey(showCalc,createkey("show-calc"));
		widget.setPreferenceForKey(keepPastData,createkey("show-keepPastData"));
		widget.setPreferenceForKey(username,createkey("username"));
		widget.setPreferenceForKey(keepPrefs,createkey("show-keepPrefs"));
		widget.setPreferenceForKey(keepPrefs,"show-keepPrefs");		// save also for standard prefs
		
		for (var i=1;i<5;i++) {
			if (presets[i].icao.length == 4) {
				widget.setPreferenceForKey(presets[i].icao,createkey("preset" + i + "-icao"));
				widget.setPreferenceForKey(presets[i].name,createkey("preset" + i + "-name"));
				widget.setPreferenceForKey(presets[i].latitude,createkey("preset" + i + "-latitude"));
				widget.setPreferenceForKey(presets[i].longitude,createkey("preset" + i + "-longitude"));
				widget.setPreferenceForKey(presets[i].timezone,createkey("preset" + i + "-timezone"));
				widget.setPreferenceForKey(parseInt(presets[i].summertime,10),createkey("preset" + i + "-summertime"));
				widget.setPreferenceForKey(presets[i].elevation,createkey("preset" + i + "-elevation"));
			}
		}
	}
}


// ---------------------------
// PREFERENCE HANDLING
// ---------------------------

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.
function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
		
	if (window.widget) {
//		if (displayFormat == 1 && !showAll)
//			window.resizeTo(318,225);
		
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
		document.getElementById('stn1inputErr').value = "";		// clear any possible error msg
		document.getElementById('stn1input').value = "";
	}
	
	front.style.display = "none";		// hide the front
	back.style.display = "block";		// show the back
	
	if (window.widget) {
		if (displayFormat == 2)
			window.resizeTo(318,245);			// should show metar first (was 230)
		
		setTimeout('widget.performTransition();', 0);		// and flip the widget over	
	}

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

	if (currentPreset >= 1 && currentPreset <= 4)
		document.getElementById("presetFront" + currentPreset).className = 'presetlabel';

	presetsDirty = false;
	checkLatestVersion();
}



// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.
function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
			
	if (window.widget) {
		if (!stationValidated) {
			stationChanged(false);
		}
		if (displayFormat == 2)
			resizeWindow(front,false,245,false);		// was 230

		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	}
	
	back.style.display = "none";			// hide the back
	front.style.display = "block";			// show the front
	
	if (window.widget) {
		if ((displayFormat == 1 && showAll) || dataSource == 2) {
			var hh = countTableHeight("plateB");
			resizeWindow(front,true,hh,false);
		}
		else {
			if (displayFormat == 1 && !showAll) {
				resizeWindow(front,false,defaultWinHeight,false);
			}
			else {
				var hh = countTableHeight("plate");
				resizeWindow(front,true,hh,false);
			}
		}
	
		setTimeout('widget.performTransition();', 0);		// and flip the widget back to the front
	}
	
	
	if (presetsDirty) {
		switch (dataSource) {
			case 1:
				currentPreset = 0;									// get new "current" preset, in case it has been removed
				for (var i=0;i<5;i++)
					if (presets[i].icao.length == 4) {				// pick first in row
						currentPreset = i;
						if (currentPreset >= 1 && currentPreset <= 4)
							document.getElementById("presetFront" + i).className = 'selectedPreset';
						break;
					}
				break;
			
			case 2:
				username = document.getElementById('usernameInput').value;
				break;
				
			default:	;
		}
			
		saveAllPrefs();
	}
	else {
		if (currentPreset >= 1 && currentPreset <= 4)
			document.getElementById("presetFront" + currentPreset).className = 'selectedPreset';
	}
			
	getAllData();
}



function resizeWindow(elementId,forceMinimum,newHeight,slow)
{
	if (newHeight > 450)			// limitation when to scroll
		newHeight = 450;

//	return;

	if (newHeight <= 230 && forceMinimum)
		newHeight = 230;		

	var curHeight = parseInt(elementId.style.height,10);
	
	if (slow) {
		if (newHeight >= curHeight) {
			for (var j=curHeight;j<newHeight;j = j + 35) {
				if (j >= newHeight)
					j = newHeight;
				if (window.widget) {
					window.resizeTo(318,j);
					elementId.style.height = j + "px";
				}
			}
		}
		if (newHeight < curHeight) {
			for (var j=curHeight;j>newHeight;j = j - 35) {
				if (j <= newHeight)
					j = newHeight;
				if (window.widget) {
					window.resizeTo(318,j);
					elementId.style.height = j + "px";
				}
			}
		}
		
	}
	elementId.style.height = newHeight + "px";
	var innerHeight = newHeight - 103;
	document.getElementById("motif").style.height = innerHeight + "px";

	if (window.widget)
		window.resizeTo(318,newHeight);
}




function changeMetric(elem)
{	
	switch(parseInt(elem.options[elem.selectedIndex].value)) {					// find out which option was chosen
		case 1: 									// if option #1 (US)
			metricFormat = 1;
			break;
		case 2:										// if option #2 (US with Celsius)
			metricFormat = 2;
			break;
		case 3:										// if option #3 (Metric)
			metricFormat = 3;
			break;
		case 4:										// if option #4 (Metric everything)
			metricFormat = 4;
			break;
	}
	presetsDirty = true;
}



function changeSource(elem)
{	
	switch(parseInt(elem.options[elem.selectedIndex].value)) {
		case 1: 									// if option #1 (NWS)
			dataSource = 1;
			
			if (displayFormat == 1) {
				document.getElementById('showRMKText').style.visibility = "hidden";
				document.getElementById('showRMKCheckbox').style.visibility = "hidden";
				document.getElementById('showTimeText').style.visibility = "hidden";
				document.getElementById('showTimeCheckbox').style.visibility = "hidden";
				document.getElementById('showCalcText').style.visibility = "hidden";
				document.getElementById('showCalcCheckbox').style.visibility = "hidden";
				document.getElementById('showAllText').style.visibility = "visible";
				document.getElementById('showAllCheckbox').style.visibility = "visible";
				document.getElementById('showRawFormatText').style.visibility = "visible";
				document.getElementById('showRawFormatCheckbox').style.visibility = "visible";
			}
			if (displayFormat == 2 || displayFormat == 3) {
				document.getElementById('showRMKText').style.visibility = "visible";
				document.getElementById('showRMKCheckbox').style.visibility = "visible";
				document.getElementById('showTimeText').style.visibility = "visible";
				document.getElementById('showTimeCheckbox').style.visibility = "visible";
				document.getElementById('showCalcText').style.visibility = "visible";
				document.getElementById('showCalcCheckbox').style.visibility = "visible";
				document.getElementById('showAllText').style.visibility = "hidden";
				document.getElementById('showAllCheckbox').style.visibility = "hidden";
				document.getElementById('showRawFormatText').style.visibility = "hidden";
				document.getElementById('showRawFormatCheckbox').style.visibility = "hidden";
			}

			document.getElementById('presetText').style.visibility = "visible";	
			for (var i=1;i<5;i++)
				document.getElementById("presetBox" + i).style.visibility = "visible"

			
			var select = document.getElementById('formatPopup');
			select.options[parseInt(displayFormat-1)].selected = true;
			changeFormat(select);
			
			if (showAll && displayFormat == 1) {
				for (var i=1;i<5;i++)
					document.getElementById("presetFront" + i).style.visibility = "hidden";
			}
			else {
				for (var i=1;i<5;i++)
					if (presets[i].icao.length == 4)
						document.getElementById("presetFront" + i).style.visibility = "visible";
			}
			
			document.getElementById('formatPopup').style.visibility = "visible";
			document.getElementById('showKeepPastDataCheckbox').style.visibility = "visible";
			document.getElementById('showKeepPastDataText').style.visibility = "visible";
			document.getElementById('stationText').style.visibility = "visible";
			document.getElementById('stn1input').style.visibility = "visible";
			document.getElementById('formatText').style.visibility = "visible";
			document.getElementById('metricPopup').style.visibility = "visible";
			document.getElementById('optionsText').style.visibility = "hidden";
			
			document.getElementById('usernameText').style.visibility = "hidden";
			document.getElementById('usernameInput').style.visibility = "hidden";

			document.getElementById('topEdge').className = "";
			document.getElementById('groupPopup').style.visibility = "hidden";
			document.getElementById('groupPopupImg').style.visibility = "hidden";
			document.getElementById('groupPopupLabel').style.visibility = "hidden";
			
			document.getElementById('usernameInfoText').innerText = "";

			break;
			
		case 2:										// if option #2 (myMetar.com)
			dataSource = 2;
			displayFormat = 1;
			firstConnection = true;

			document.getElementById('showRMKText').style.visibility = "hidden";
			document.getElementById('showRMKCheckbox').style.visibility = "hidden";
			document.getElementById('showTimeText').style.visibility = "hidden";
			document.getElementById('showTimeCheckbox').style.visibility = "hidden";
			document.getElementById('showAllText').style.visibility = "hidden";
			document.getElementById('showAllCheckbox').style.visibility = "hidden";
			document.getElementById('showCalcCheckbox').style.visibility = "hidden";
			document.getElementById('showCalcText').style.visibility = "hidden";
			document.getElementById('showRawFormatText').style.visibility = "visible";
			document.getElementById('showRawFormatCheckbox').style.visibility = "visible";
			document.getElementById('formatPopup').style.visibility = "hidden";
			document.getElementById('showKeepPastDataCheckbox').style.visibility = "hidden";
			document.getElementById('showKeepPastDataText').style.visibility = "hidden";
			document.getElementById('stationText').style.visibility = "hidden";
			document.getElementById('stn1input').style.visibility = "hidden";
			document.getElementById('formatText').style.visibility = "hidden";
			document.getElementById('metricPopup').style.visibility = "hidden";
			document.getElementById('optionsText').style.visibility = "visible";

			timePrevImg.style.visibility = "hidden";
			timeNextImg.style.visibility = "hidden";

			document.getElementById('usernameText').style.visibility = "visible";
			document.getElementById('usernameInput').style.visibility = "visible";
			
			document.getElementById('presetText').style.visibility = "hidden";	
			for (var i=1;i<5;i++)
				document.getElementById("presetBox" + i).style.visibility = "hidden"


			for (var i=1;i<5;i++) {
				document.getElementById("presetFront" + i).style.visibility = "hidden";
			}

			document.getElementById('topEdge').className = "popup";
			document.getElementById('groupPopup').style.visibility = "visible";
			document.getElementById('groupPopupImg').style.visibility = "visible";
			document.getElementById('groupPopupLabel').style.visibility = "visible";
			
			document.getElementById('usernameInfoText').innerText = getLocalizedString("More information at") + ": " + "www.MyMetar.com";
			break;
	}
	presetsDirty = true;
}



function changeFormat(elem)
{	
	switch(parseInt(elem.options[elem.selectedIndex].value)) {
		case 1: 									// if option #1 (Raw)
			displayFormat = 1;
			document.getElementById('showRMKText').style.visibility = "hidden";
			document.getElementById('showRMKCheckbox').style.visibility = "hidden";
			document.getElementById('showTimeText').style.visibility = "hidden";
			document.getElementById('showTimeCheckbox').style.visibility = "hidden";
			document.getElementById('showCalcText').style.visibility = "hidden";
			document.getElementById('showCalcCheckbox').style.visibility = "hidden";
			document.getElementById('showAllText').style.visibility = "visible";
			document.getElementById('showAllCheckbox').style.visibility = "visible";
			document.getElementById('showRawFormatText').style.visibility = "visible";
			document.getElementById('showRawFormatCheckbox').style.visibility = "visible";
			document.getElementById('metricPopup').style.visibility = "visible";
			if (showAll)
				for (var i=1;i<5;i++)
					document.getElementById("presetFront" + i).style.visibility = "hidden";
			
			document.getElementById('reportTypeImage').className = "";
			break;
		case 2:										// if option #2 (Translated)
			displayFormat = 2;
			document.getElementById('showAllText').style.visibility = "hidden";
			document.getElementById('showAllCheckbox').style.visibility = "hidden";
			document.getElementById('showRawFormatText').style.visibility = "hidden";
			document.getElementById('showRawFormatCheckbox').style.visibility = "hidden";
			document.getElementById('showRMKText').style.visibility = "visible";
			document.getElementById('showRMKCheckbox').style.visibility = "visible";
			document.getElementById('showTimeText').style.visibility = "visible";
			document.getElementById('showTimeCheckbox').style.visibility = "visible";
			document.getElementById('metricPopup').style.visibility = "visible";
			document.getElementById('showCalcCheckbox').style.visibility = "visible";
			document.getElementById('showCalcText').style.visibility = "visible";
			for (var i=1;i<5;i++)
				if (presets[i].icao.length == 4)
					document.getElementById("presetFront" + i).style.visibility = "visible";

			break;
		case 3:										// if option #3 (Graphical)
			displayFormat = 3;
			document.getElementById('showAllText').style.visibility = "hidden";
			document.getElementById('showAllCheckbox').style.visibility = "hidden";
			document.getElementById('showRMKText').style.visibility = "hidden";
			document.getElementById('showRMKCheckbox').style.visibility = "hidden";
			document.getElementById('showRawFormatText').style.visibility = "hidden";
			document.getElementById('showRawFormatCheckbox').style.visibility = "hidden";
			document.getElementById('showTimeText').style.visibility = "visible";
			document.getElementById('showTimeCheckbox').style.visibility = "visible";
			document.getElementById('metricPopup').style.visibility = "visible";
			document.getElementById('showCalcCheckbox').style.visibility = "hidden";
			document.getElementById('showCalcText').style.visibility = "hidden";
			for (var i=1;i<5;i++)
				if (presets[i].icao.length == 4)
					document.getElementById("presetFront" + i).style.visibility = "visible";

			break;
	}
	
	presetsDirty = true;
}


function showAllChanged()
{
	showAll = document.getElementById('showAllCheckbox').checked;

	if (window.widget) {
		if (showAll) {
			for (var i=1;i<5;i++)
				document.getElementById("presetFront" + i).style.visibility = "hidden";
		}
		else {
			for (var i=1;i<5;i++)
				if (presets[i].icao.length == 4)
					document.getElementById("presetFront" + i).style.visibility = "visible";
		}
	}
	presetsDirty = true;
}


function showAllTextClick(elem)
{
	var element = document.getElementById('showAllCheckbox');
	element.checked = !element.checked;
	showAllChanged();
}


function showRMKChanged()
{
	showRMK = document.getElementById('showRMKCheckbox').checked;

	presetsDirty = true;
}


function showRMKTextClick(elem)
{
	var element = document.getElementById('showRMKCheckbox');
	element.checked = !element.checked;
	showRMKChanged();
}


function showRawFormatChanged()
{
	showRawFormat = document.getElementById('showRawFormatCheckbox').checked;

	presetsDirty = true;
}


function showRawFormatTextClick(elem)
{
	var element = document.getElementById('showRawFormatCheckbox');
	element.checked = !element.checked;
	showRawFormatChanged();
}


function showTimeChanged()
{
	showLocalTime = document.getElementById('showTimeCheckbox').checked;

	presetsDirty = true;
}


function showTimeTextClick(elem)
{
	var element = document.getElementById('showTimeCheckbox');
	element.checked = !element.checked;
	showTimeChanged();
}


function showCalcChanged()
{
	showCalc = document.getElementById('showCalcCheckbox').checked;

	presetsDirty = true;
}


function showCalcTextClick(elem)
{
	var element = document.getElementById('showCalcCheckbox');
	element.checked = !element.checked;
	showCalcChanged();
}



function showKeepPrefsChanged()
{
	keepPrefs = document.getElementById('showKeepPrefsCheckbox').checked;

	presetsDirty = true;
}


function showKeepPrefsTextClick(elem)
{
	var element = document.getElementById('showKeepPrefsCheckbox');
	element.checked = !element.checked;
	showKeepPrefsChanged();
}


function showKeepPastDataChanged()
{
	keepPastData = document.getElementById('showKeepPastDataCheckbox').checked;

	presetsDirty = true;
}


function showKeepPastDataTextClick(elem)
{
	var element = document.getElementById('showKeepPastDataCheckbox');
	element.checked = !element.checked;
	showKeepPastDataChanged();
}


function presetClick(elem)
{	
	var element = document.getElementById("presetBox" + elem);
	
	if (element.innerText.length == 4 && element.innerText == presets[0].icao) {		// clear preset, if same as input-line
		element.innerText = "+";
		document.getElementById("presetFront" + elem).style.visibility = "hidden";
		document.getElementById("presetFront" + elem).innerText = "";
		presets[elem].icao = "";
		presets[elem].name = "";
	}
	else {
		if (presets[0].icao.length == 4) {											// set preset
			element.innerText = presets[0].icao;
			if ((!showAll && displayFormat == 1) || displayFormat == 2) {
				for (var i=1;i<5;i++) {
					if (i != elem) {
						var element = document.getElementById("presetFront" + i);
						element.className = 'presetlabel';
					}
				}
				document.getElementById("presetFront" + elem).style.visibility = "visible";
//				document.getElementById("presetFront" + elem).className = "selectedPreset";
			}
			document.getElementById("presetFront" + elem).innerText = presets[0].icao;

			presets[elem].icao = presets[0].icao;
			presets[elem].name = presets[0].name;
			presets[elem].latitude = presets[0].latitude;
			presets[elem].longitude = presets[0].longitude;
			presets[elem].timezone = presets[0].timezone;
			presets[elem].summertime = presets[0].summertime;
			presets[elem].elevation = presets[0].elevation;
			
			presets[0].icao = "";
			presets[0].name = "";
		}
		else {																		// clear preset
			element.innerText = "+";
			document.getElementById("presetFront" + elem).style.visibility = "hidden";
			document.getElementById("presetFront" + elem).innerText = "";
			presets[elem].icao = "";
			presets[elem].name = "";
		}
	}
	presetsDirty = true;
}


function presetChanged(elem)
{

	if (fetchInProgress)						// don't change during updating
		return;
		
	stopAllAnimationTimers();

	for (var i=1;i<5;i++) {
		var element = document.getElementById("presetFront" + i);
		if (i != elem) {
			element.className = 'presetlabel';
		}
		else {
			if (element.innerText.length == 4) {
				currentPreset = parseInt(elem,10);
				if (keepPastData)
					resetTimePrevNext();								// reset past data
				if (!firstConnection)
					displayData();
				element.className = 'selectedPreset';
			}
			else {
				element.className = 'presetlabel';
			}
		}
	}
	
	if (displayFormat == 1 && !showAll)	
		toggleTaf = true;
		
	var element = document.getElementById("presetFront" + elem);
}


var stationValidated = false;				// should be false -  true for test in safari
function stationChanged(withMenu)
{
	var newStation = document.getElementById('stn1input').value;
	document.getElementById('stn1inputErr').innerText = "";
	
	if (newStation.length <= 1) {
		presets[0].icao = "";
		presets[0].name = "";
		document.getElementById('stn1input').value = "";
		return;			
	}


	var j = 0;
	var tmpposA = 0;
	var tmpposB = 0;
	var upStr = newStation.toUpperCase();
	var upArr = "";
	var foundStations = new Array();
	
													// parse station list
	for (var i=0;i<stationlist.length;i++) {
		upArr = stationlist[i].n.toUpperCase();
		if (upArr.indexOf(upStr,0) != -1) {
			var obj = new Object();
			tmpposA = 0;
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			obj.icao = stationlist[i].n.substring(tmpposA,tmpposB);
			tmpposA = tmpposB + 1;
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			obj.name =stationlist[i].n.substring(tmpposA,tmpposB);	
			tmpposA = tmpposB + 1;
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			if ((tmpposB - tmpposA) <= 1)
				obj.state = "";
			else
				obj.state = stationlist[i].n.substring(tmpposA,tmpposB);
			tmpposA = tmpposB + 1;	
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			obj.country = stationlist[i].n.substring(tmpposA,tmpposB);
			tmpposA = tmpposB + 1;	
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			obj.latitude = stationlist[i].n.substring(tmpposA,tmpposB);	
			tmpposA = tmpposB + 1;
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			obj.longitude = stationlist[i].n.substring(tmpposA,tmpposB);
			tmpposA = tmpposB + 1;	
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			obj.timezone = stationlist[i].n.substring(tmpposA,tmpposB);	
			tmpposA = tmpposB + 1;
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			obj.summertime = parseInt(stationlist[i].n.substring(tmpposA,tmpposB),10);
			tmpposA = tmpposB + 1;
			tmpposB = stationlist[i].n.length;
			obj.elevation = stationlist[i].n.substring(tmpposA,tmpposB);

			foundStations.push(obj);
			j++;
		}
	}

/*
	if (!withMenu) {				// just do check (when prefs are closed)
		if (i == 1) {				// at least one was found
			stationValidated = true;
			var newStationIcao = foundStationsIcao[0];
			if (foundStationsState[0].length == 0)
				var newStationName = foundStations[0] + ", " + foundStationsCountry[0];
			else
				var newStationName = foundStations[0] + ", " + foundStationsState[0] + ", " + foundStationsCountry[0];
		}
		else {
			var newStationIcao = newStation;
			var newStationName = newStation;
		}
		
		presetIcao[0] = newStationIcao;
		presetName[0] = newStationName;
		document.getElementById('stn1input').value = presetName[0];
		return;			
	}
*/
	
	if (foundStations.length > 1) {
		var menu = null;
		if (window.widget)
			menu = widget.createMenu();
		
		for (var i=0;i<foundStations.length;i++) {							// fill in menu
			var country = getCountryName(foundStations[i].country);
			if (foundStations[i].state == "")
				menu.addMenuItem (foundStations[i].name + ", " + country);
			else
				menu.addMenuItem (foundStations[i].name + ", " + foundStations[i].state + ", " + country);	// include state for US stations
		}
		
		
		var topOffset = 0;
		var leftOffset = 0;
		if (menu != null) {
			var selectedItem = menu.popup(leftOffset + 102, topOffset + 52);
			if (selectedItem >= 0) {
				stationValidated = true;
				if (foundStations[selectedItem].state == "") {
				if (foundStations[selectedItem].name.length >= 19)										// cut long names
					foundStations[selectedItem].name = foundStations[selectedItem].name.substr(0,20) + "...";
					presets[0].name = foundStations[selectedItem].name + ", " + foundStations[selectedItem].country;
				}
				else {
				if (foundStations[selectedItem].name.length >= 15)										// cut long names
					foundStations[selectedItem].name = foundStations[selectedItem].name.substr(0,16) + "...";
					presets[0].name = foundStations[selectedItem].name + ", " + foundStations[selectedItem].state + ", " + foundStations[selectedItem].country;
				}
				presets[0].icao = foundStations[selectedItem].icao;
				presets[0].latitude = foundStations[selectedItem].latitude;
				presets[0].longitude = foundStations[selectedItem].longitude;
				presets[0].summertime = foundStations[selectedItem].summertime;
				presets[0].timezone = foundStations[selectedItem].timezone;
				presets[0].elevation = foundStations[selectedItem].elevation;
				document.getElementById('stn1input').value = presets[0].name
			}
			else {						// no station from menu has been selected
				document.getElementById('stn1input').value = "";
				stationValidated = false;
				presets[0].icao = "";
				presets[0].name = "";
				return;
			}
		}
	}
	else
		if (foundStations.length == 1) {
			if (foundStations[0].state == "") {
				if (foundStations[0].name.length >= 19)										// cut long names
					foundStations[0].name = foundStations[0].name.substr(0,20) + "...";
				presets[0].name = foundStations[0].name + ", " + foundStations[0].country;
			}
			else {
				if (foundStations[0].name.length >= 15)										// cut long names
					foundStations[0].name = foundStations[0].name.substr(0,16) + "...";
				presets[0].name = foundStations[0].name + ", " + foundStations[0].state + ", " + foundStations[0].country;
			}
			
			presets[0].icao = foundStations[0].icao;
			presets[0].latitude = foundStations[0].latitude;
			presets[0].longitude = foundStations[0].longitude;
			presets[0].summertime = foundStations[0].summertime;
			presets[0].timezone = foundStations[0].timezone;
			presets[0].elevation = foundStations[0].elevation;
			document.getElementById('stn1input').value = presets[0].name;
		}
		else {
			stationValidated = false;
		
			// nothing found
			return;
		}
}


function findStationElevation(icao)
{
	var tmpposA = 0;
	var tmpposB = 0;
	var upStr = icao.toUpperCase();
	var upArr = "";
	
													// parse station list
	for (var i=0;i<stationlist.length;i++) {
		upArr = stationlist[i].n.toUpperCase();
		if (upArr.indexOf(upStr,0) != -1) {
			tmpposA = 0;
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			tmpposA = tmpposB + 1;
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			tmpposA = tmpposB + 1;
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			tmpposA = tmpposB + 1;	
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			tmpposA = tmpposB + 1;	
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			tmpposA = tmpposB + 1;
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			tmpposA = tmpposB + 1;	
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			tmpposA = tmpposB + 1;
			tmpposB = stationlist[i].n.indexOf("\t",tmpposA);
			tmpposA = tmpposB + 1;
			tmpposB = stationlist[i].n.length;
			var elev = stationlist[i].n.substring(tmpposA,tmpposB);
			
			return elev;
			break;
		}
	}
}




function getCountryName(isoCode)
{
	var tmppos = 0;
	var tmppos2 = 0;
	var countryName = "";
	
	tmppos = countrylist.indexOf(";"+isoCode,0);
	if (tmppos >= 0) {
		tmppos2 = countrylist.indexOf(";",tmppos+1);
		if (tmppos2 >= 0)
			countryName = countrylist.substring(tmppos+4,tmppos2);
		else
			countryName = "";
	}
	else {
		countryName = "";
	}
	
	return countryName;
}


function usernameTyping(event)
{
	presetsDirty = true;
	firstConnection = true;
//	populateMyMetarGroupMenu(actGroupData);
	station1Body.innerText = "";
}


function stationTyping(event)
{
	stationValidated = false;			// should be false - true for test in safari
	presetsDirty = true;
	if (document.getElementById('stn1input').value.length >=4)
		document.getElementById('stn1inputErr').innerText = getLocalizedString("Press Return, Enter, or Tab to validate.");
	else 
		document.getElementById('stn1inputErr').innerText = "";
}


function stationKeyPress(event)
{
	switch (event.keyCode) {
		case 13: // return
		case 3:  // enter
		case 9:  // tab
			if (!stationValidated) {
				stationChanged(true);
			}
			break;
	}
}



function stripHtml(htmlText) 
{
	var rawText = "";
	var htmlLen = htmlText.length;
	var tag = false;

	for (var i=0;i<htmlLen;i++) {
		if (!tag) {
			if (htmlText.charAt(i) == "<") {
				tag = true;
				if (htmlText.charAt(i+1).toUpperCase() == "B" && htmlText.charAt(i+2).toUpperCase() == "R")
					rawText = rawText + "\r\n";
				if (htmlText.charAt(i+1).toUpperCase() == "T" && htmlText.charAt(i+2).toUpperCase() == "R")
					rawText = rawText + "\r\n";

				continue;
			}
			rawText = rawText + htmlText.charAt(i);
		}
		else {
			if (htmlText.charAt(i) == ">") {
				tag = false;
			}
		}
	}
	return rawText;
}


function copyClipboard() 
{
	if (dataSource == 2)
		return;

	var clipboardText = "";

	for (var i=0;i<5;i++) {
		if (presets[i].icao.length == 4) {
			clipboardText = clipboardText + presets[i].name + " (" + presets[i].icao + ")\r\n";
			if (displayFormat == 1)
				clipboardText = clipboardText + "METAR: " + stripHtml(actDataDisplay[i].mTextRaw) + "\r\n\r\n" + "TAF: " + stripHtml(actDataDisplay[i].tTextRaw) + "\r\n\r\n";
			if (displayFormat == 2)
				clipboardText = clipboardText + "METAR: " + stripHtml(displayDateLine(actDataDisplay[i].mDate,i,true,showLocalTime)) + stripHtml(actDataDisplay[i].mTextTrans) + "\r\n\r\n" 
												+ "TAF: " + stripHtml(displayDateLine(actDataDisplay[i].tDate,i,true,showLocalTime)) + stripHtml(actDataDisplay[i].tTextTrans) + "\r\n\r\n";
		}
	}

	if (window.widget) {
		var cp = widget.system("/usr/bin/pbcopy",copydone);
		cp.write(clipboardText);
		cp.close();
	}
}


function copydone() 
{
	cp = null;
}



function changeGroup(elem)
{	

	var selGroup = parseInt(elem.options[elem.selectedIndex].value);
	actGroupDataSelected = selGroup;
	
	document.getElementById('groupPopupLabel').innerText = actGroupData[selGroup].groupName;
	
	displayData();
}


// ---------------------------
// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)
// ---------------------------

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');				// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}


